*** linux-2.0.28/net/ipv4/tcp_input.c	Sat Nov 30 02:51:03 1996
--- KERNEL/net/ipv4/tcp_input.c	Mon Nov 24 22:52:31 1997
***************
*** 2084,2094 ****
  	 *	I have time to test it hard and look at what gcc outputs 
  	 */
  
! 	if (!tcp_sequence(sk, skb->seq, skb->end_seq-th->syn))
! 	{
! 		bad_tcp_sequence(sk, th, skb->end_seq-th->syn, dev);
  		kfree_skb(skb, FREE_READ);
  		return 0;
  	}
  
  	if(th->rst)
--- 2707,2726 ----
  	 *	I have time to test it hard and look at what gcc outputs 
  	 */
  
! 	/* Hacked the interface to tcp_sequence() for duplicate SYNACKs. */
! 	switch (tcp_sequence(sk, skb->seq, skb->end_seq-th->syn)) {
! 	case 2: /* specific bad sequence number: a duplicate packet */
! 		if (sk->scanpair && th->syn && th->ack)
! 			/* handle duplicate SYNACKs */
! 			handle_dupsynack(sk, skb, th);
! 		/* fall thru */
! 	case 0: /* all bad sequence numbers */
! 		bad_tcp_sequence(sk, th, skb->end_seq-th->syn, dev, skb);
  		kfree_skb(skb, FREE_READ);
  		return 0;
+ 	case 1: /* good sequence number */
+ 	default:
+ 		break;
  	}
  
  	if(th->rst)
***************
*** 2111,2117 ****
  	 
  	if(th->syn && skb->seq!=sk->syn_seq)
  	{
! 		tcp_send_reset(daddr,saddr,th, &tcp_prot, opt, dev,0, 255);
  		return tcp_reset(sk,skb);	
  	}
  
--- 2743,2749 ----
  	 
  	if(th->syn && skb->seq!=sk->syn_seq)
  	{
! 		tcp_send_reset(daddr,saddr,th, &tcp_prot, opt, dev,0, 255,skb);
  		return tcp_reset(sk,skb);	
  	}
  
***************
*** 2120,2126 ****
  	 */
  	 
  
! 	if(th->ack && !tcp_ack(sk,th,skb->ack_seq,len))
  	{
  		/*
  		 *	Our three way handshake failed.
--- 2752,2758 ----
  	 */
  	 
  
! 	if(th->ack && !tcp_ack(sk,th,skb->ack_seq,len,skb))
  	{
  		/*
  		 *	Our three way handshake failed.
***************
*** 2128,2134 ****
  		 
  		if(sk->state==TCP_SYN_RECV)
  		{
! 			tcp_send_reset(daddr, saddr, th,sk->prot, opt, dev,0,255);
  		}
  		kfree_skb(skb, FREE_READ);
  		return 0;
--- 2760,2767 ----
  		 
  		if(sk->state==TCP_SYN_RECV)
  		{
! 			tcp_send_reset(daddr, saddr, th, sk->prot, opt,
! 				dev, 0, 255, skb);
  		}
  		kfree_skb(skb, FREE_READ);
  		return 0;
***************
*** 2172,2178 ****
  	/*
  	 *	No such TCB. If th->rst is 0 send a reset (checked in tcp_send_reset)
  	 */
! 	tcp_send_reset(daddr, saddr, th, &tcp_prot, opt,dev,0,255);
  
  discard_it:
  	/*
--- 2805,2811 ----
  	/*
  	 *	No such TCB. If th->rst is 0 send a reset (checked in tcp_send_reset)
  	 */
! 	tcp_send_reset(daddr, saddr, th, &tcp_prot, opt, dev, 0, 255, skb);
  
  discard_it:
  	/*
*** linux-2.0.28/net/ipv4/tcp_output.c	Mon Sep  2 05:18:26 1996
--- KERNEL/net/ipv4/tcp_output.c	Mon Nov 24 22:55:05 1997
***************
*** 28,33 ****
--- 28,34 ----
  #include <linux/ip_fw.h>
  #include <linux/firewall.h>
  #include <linux/interrupt.h>
+ #include <linux/if_ether.h>
  
  
  /*
***************
*** 164,169 ****
--- 165,175 ----
  	skb->seq = ntohl(th->seq);
  	skb->end_seq = skb->seq + size - 4*th->doff;
  
+ 	/* This is new here because now send_skb can send a FIN. */
+ 	/* Failure to do this can cause write_xmit to drop this packet. */
+ 	if(th->fin)
+ 		skb->end_seq++;
+ 
  	/*
  	 *	We must queue if
  	 *
***************
*** 444,449 ****
--- 450,475 ----
  		 *	Discard the surplus MAC header
  		 */
  		 
+ 		/*
+ 		 * SCANHACK: I may want to reconsider this in the future.
+ 		 * This does make every attempt to find the right destination
+ 		 * MAC addr.  It can find the latest dest in sk->hw_addr.
+ 		 *
+ 		 * An alternative to this ugly goto is to set up a fake
+ 		 * rtable and hh_cache to follow the normal flow.  That
+ 		 * looks like more work than it is worth.
+ 		 */
+ 		if (sk->scandev)
+ 		{
+ 			iph = skb->ip_hdr;
+ 			th = (struct tcphdr *)(((char *)iph) + (iph->ihl << 2));
+ 			size = ntohs(iph->tot_len) - (iph->ihl<<2);
+ 			iph->id = htons(ip_id_count++);
+ 			ip_send_check(iph);
+ 			skb->dev = dev = sk->scandev;
+ 			skb->arp = 1;
+ 			goto scanhack;
+ 		}
  		skb_pull(skb,((unsigned char *)skb->ip_hdr)-skb->data);
  
  		/*
***************
*** 540,545 ****
--- 566,572 ----
  			 *	this up by avoiding a full checksum.
  			 */
  		 
+ scanhack:
  			th->ack_seq = htonl(sk->acked_seq);
  			clear_delayed_acks(sk);
  			th->window = ntohs(tcp_select_window(sk));
***************
*** 614,620 ****
   */
   
  void tcp_send_reset(unsigned long saddr, unsigned long daddr, struct tcphdr *th,
! 	  struct proto *prot, struct options *opt, struct device *dev, int tos, int ttl)
  {
  	struct sk_buff *buff;
  	struct tcphdr *t1;
--- 641,648 ----
   */
   
  void tcp_send_reset(unsigned long saddr, unsigned long daddr, struct tcphdr *th,
! 	struct proto *prot, struct options *opt, struct device *dev, int tos,
! 	int ttl, struct sk_buff *skb)
  {
  	struct sk_buff *buff;
  	struct tcphdr *t1;
***************
*** 646,658 ****
  	 *	Put in the IP header and routing stuff. 
  	 */
  
! 	tmp = prot->build_header(buff, saddr, daddr, &ndev, IPPROTO_TCP, opt,
! 			   sizeof(struct tcphdr),tos,ttl,NULL);
! 	if (tmp < 0) 
  	{
!   		buff->free = 1;
! 		sock_wfree(NULL, buff);
! 		return;
  	}
  
  	t1 =(struct tcphdr *)skb_put(buff,sizeof(struct tcphdr));
--- 674,714 ----
  	 *	Put in the IP header and routing stuff. 
  	 */
  
! 	if (skb && skb->ipcatch)
  	{
! 		/* do it manually because my ARP hooks do not work for resets */
! 		struct iphdr *iph;
! 		struct ethhdr *eth1 = skb->mac.ethernet;
! 		struct ethhdr *eth2;
! 
! 		ndev = skb->dev;
! 		skb_reserve(buff, MAX_HEADER);
! 		eth2 = (struct ethhdr *) skb_push(buff, ndev->hard_header_len);
! 		iph = buff->ip_hdr = (struct iphdr *) skb_put(buff, 20);
! 
! 		memcpy(eth2->h_dest, eth1->h_source, 6);
! 		memcpy(eth2->h_source, eth1->h_dest, 6);
! 		eth2->h_proto = eth1->h_proto;
! 
! 		iph->version  = 4;
! 		iph->ihl      = 5;
! 		iph->tos      = tos;
! 		iph->frag_off = 0;
! 		iph->ttl      = ttl;
! 		iph->daddr    = daddr;
! 		iph->saddr    = saddr;
! 		iph->protocol = IPPROTO_TCP;
! 	}
! 	else
! 	{
! 		tmp = prot->build_header(buff, saddr, daddr, &ndev, IPPROTO_TCP,
! 				opt, sizeof(struct tcphdr),tos,ttl,NULL);
! 		if (tmp < 0) 
! 		{
! 			buff->free = 1;
! 			sock_wfree(NULL, buff);
! 			return;
! 		}
  	}
  
  	t1 =(struct tcphdr *)skb_put(buff,sizeof(struct tcphdr));
***************
*** 931,936 ****
--- 987,996 ----
  	    && skb_queue_empty(&sk->write_queue)
  	    && sk->ip_xmit_timeout == TIME_WRITE)
  	{
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ 		if (sk->dontcare)
+ 			log_sockevent(sk, 16, 0, 0);
+ #endif /* CONFIG_WEBSHIELD_DEBUG */
  		if (sk->keepopen)
  			tcp_reset_xmit_timer(sk,TIME_KEEPOPEN,TCP_TIMEOUT_LEN);
  		else
***************
*** 1252,1255 ****
--- 1312,1464 ----
  	/* Checksum the shrunk buffer */
  	tcp_send_check(th, sk->saddr, sk->daddr, 
  		   th->doff * 4 + len , skb);
+ }
+ 
+ /*
+  *	Make a best attempt at forwarding a connection setup packet.
+  *	This is used by scanned sockets during connection setup to
+  *	handle SYNs, SYNACKs, ACKs of SYNACKs, and retransmits.
+  *	It sends the packet with free=1 to prevent queueing for
+  *	automatic retransmission.
+  */
+ void make_syn_pkt(struct sock *sk, struct sk_buff *skb, struct tcphdr *th)
+ {
+ 	struct sk_buff *buff;
+ 	int tmp;
+ 	struct tcphdr *t1;
+ 	struct device *ndev;
+ 	unsigned char *ptr;
+ 	int pkt_size;
+ 	int seg_size;
+ 
+ #ifndef CONFIG_BRIDGE
+ 	ndev = skb->dev->devpair;
+ #else
+ 	ndev = skb->dev;	/* good enough for intelligent bridge */
+ #endif
+ 	if(!ndev)
+ 	{
+ 		printk("no device pair?\n");
+ 		return;
+ 	}
+ 
+ 	/* only SYN/SYNACK packets get TCP options */
+ 	if(th->syn)
+ 	{
+ 		seg_size = 24;
+ 		pkt_size = MAX_SYN_SIZE;
+ 	}
+ 	else
+ 	{
+ 		seg_size = 20;
+ 		pkt_size = MAX_SYN_SIZE - 4;
+ 	}
+ 	buff = sock_wmalloc(sk, pkt_size, 1, GFP_ATOMIC);
+ 	if (buff == NULL) 
+ 	{
+ 		/* Oh, well.  Maybe next retransmit will have better luck. */
+ 		printk("dropping forwarded packet\n");
+ 		return;
+ 	}
+ 	buff->protocol = htons(ETH_P_IP);
+ 	buff->sk = sk;
+ 	buff->arp = 1;
+ 	buff->localroute = sk->localroute;
+ 
+ 	/*
+ 	 * Copy MAC and IP:
+ 	 *
+ 	 * Reserving space for the MAC header moves the focal points up
+ 	 * to the middle of skbLogical space.  The push allocates some
+ 	 * of the reserved space for the use by the MAC header at
+ 	 * skb->data, the front focal point.  The put allocates space
+ 	 * for the IP header up to skb->tail, the tail focal point.
+ 	 */
+ 	skb_reserve(buff, MAX_HEADER);
+ 	ptr = skb_push(buff, ndev->hard_header_len);
+ 	buff->ip_hdr = (struct iphdr *) skb_put(buff, 20);
+ 	tmp = ndev->hard_header_len + 20;
+ 	memcpy(buff->data, skb->mac.raw, tmp);
+ 	buff->ip_hdr->ihl = 5;		/* no IP options */
+ 	buff->indev = skb->indev;	/* try to fix a SYN war */
+ 
+ 	/* Allocate space for the TCP header. */
+ 	t1 = (struct tcphdr *) skb_put(buff, sizeof(struct tcphdr));
+ 
+ 	memcpy(t1, (void *)&(sk->dummy_th), sizeof(*t1));
+ 	/* these next 5 lines seem to be the hardest to get right */
+ 	t1->seq = th->seq;
+ /* BRYAN: I am not really sure if these two lines are necessary now. */
+ 	buff->seq = skb->seq;
+ 	buff->end_seq = buff->seq+1;
+ 	t1->ack = th->ack;
+ 	t1->ack_seq = th->ack_seq;
+ 
+ 	t1->window = ntohs(sk->window);
+ 	t1->res1=0;
+ 	t1->res2=0;
+ 	t1->rst = 0;
+ 	t1->urg = 0;
+ 	t1->psh = 0;
+ 	t1->syn = th->syn;
+ 	t1->urg_ptr = 0;
+ 	t1->doff = (th->syn) ? 6 : 5;
+ 
+ 	/*
+ 	 *	Put in the TCP options to say MTU. 
+ 	 */
+ 
+ 	buff->csum = 0;
+ 	if(th->syn)
+ 	{
+ 		ptr = skb_put(buff, 4);
+ 		ptr[0] = 2;
+ 		ptr[1] = 4;
+ 		ptr[2] = (sk->mtu) >> 8;
+ 		ptr[3] = (sk->mtu) & 0xff;
+ 		buff->csum = csum_partial(ptr, 4, 0);
+ 	}
+ 	tcp_send_check(t1, sk->saddr, sk->daddr, seg_size, buff);
+ 	/* Use 2 so ip_queue_xmit() does not increase IP packet id. */
+ 	sk->prot->queue_xmit(sk, ndev, buff, 2);
+ 
+ 	/* reset timer on client sock */
+ 	if (!sk->scanclient)
+ 		sk = sk->scanpair;
+ 	if (sk->state == TCP_SYN_RECV || sk->state == TCP_SYN_SENT ||
+ 		sk->scanpair->state == TCP_SYN_RECV ||
+ 		sk->scanpair->state == TCP_SYN_SENT)
+ 		tcp_reset_xmit_timer(sk, TIME_NEWSCAN, 4*60*HZ); /* 4 minutes */
+ 	else
+ 		del_timer(&sk->retransmit_timer);
+ }
+ 
+ void handle_dupsynack(struct sock *sk, struct sk_buff *skb, struct tcphdr *th)
+ {
+ 	struct sock *sk2 = sk->scanpair;
+ 
+ 	/* only do this duplicate SYNACK transmission in the right state */
+ 	if (!sk2 || sk->state != TCP_ESTABLISHED)
+ 	{
+ 		printk("dupsynack dropping forward: wrong state %d\n",
+ 			sk->state);
+ 		return;
+ 	}
+ 	if (sk2->state == TCP_SYN_RECV)
+ 	{
+ 		/* We never received the ACK of the SYNACK.  Try again. */
+ 		if (sk2->write_seq != skb->seq+1)
+ 		{
+ 			printk("dupsynack dropping forward: ISS %d+1 != %d\n",
+ 				(int) skb->seq, (int) sk2->write_seq);
+ 			return;
+ 		}
+ 		make_syn_pkt(sk->scanpair, skb, th);
+ 	}
+ 	else
+ 	{
+ 		/* The SYNACK sender did not receive the ACK of the */
+ 		/* SYNACK we previously forwarded.  Send a new ACK. */
+ 		tcp_send_ack(sk);
+ 	}
  }
*** linux-2.0.28/net/ipv4/tcp_timer.c	Sun Jun  2 03:23:13 1996
--- KERNEL/net/ipv4/tcp_timer.c	Mon Nov 24 22:55:24 1997
***************
*** 26,31 ****
--- 26,33 ----
  
  #include <net/tcp.h>
  
+ extern void tcp_preclose(struct sock *sk);
+ 
  void tcp_delack_timer(unsigned long data)
  {
  	tcp_send_ack((struct sock *) data);
***************
*** 38,43 ****
--- 40,51 ----
  void tcp_reset_xmit_timer(struct sock *sk, int why, unsigned long when)
  {
  	del_timer(&sk->retransmit_timer);
+ 
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ 	if(sk->dontcare)
+ 		log_sockevent(sk, 14, why, when);
+ #endif /* CONFIG_WEBSHIELD_DEBUG */
+ 
  	sk->ip_xmit_timeout = why;
  	if (why == TIME_WRITE) {
  		/* In this case we want to timeout on the first packet
***************
*** 178,183 ****
--- 186,192 ----
  		sk->error_report(sk);
  		del_timer(&sk->retransmit_timer);
  		tcp_statistics.TcpAttemptFails++;	/* Is this right ??? - FIXME - */
+ 		tcp_preclose(sk);
  		tcp_set_state(sk,TCP_CLOSE);
  		/* Don't FIN, we got nothing back */
  		return 0;
***************
*** 206,211 ****
--- 215,221 ----
  			/*
  			 *	Clean up time.
  			 */
+ 			tcp_preclose(sk);
  			tcp_set_state(sk, TCP_CLOSE);
  			return 0;
  		}
***************
*** 292,297 ****
--- 302,331 ----
  		sk->retransmits++;
  		sk->prot->retransmits++;
  		tcp_write_timeout(sk);
+ 		break;
+ 
+ 	case TIME_NEWSCAN:
+ 		/*
+ 		 * Kill both socks in an incomplete connection.
+ 		 * This timer is only set on the client sock.
+ 		 * Since the scanpair has no reference, mark it dead.
+ 		 */
+ 		if (sk->scanpair) {
+ 			struct sock *sk2 = sk->scanpair;
+ 			sk2->dead = 1;
+ 			tcp_preclose(sk2);
+ 			tcp_set_state(sk2, TCP_CLOSE);
+ 		}
+ 		/*
+ 		 * On the listener queue, closed incomplete connections are
+ 		 * destroyed by the listener in inet_accept().
+ 		 */
+ 		tcp_preclose(sk);
+ 		if (!sk->dead) {
+ 			sk->state = TCP_CLOSE;
+ 			sk->state_change(sk);
+ 		} else
+ 			tcp_set_state(sk, TCP_CLOSE);
  		break;
  
  	default:
*** linux-2.0.28/net/ipv4/timer.c	Thu Feb 22 06:50:46 1996
--- KERNEL/net/ipv4/timer.c	Mon Nov 24 22:55:38 1997
***************
*** 87,92 ****
--- 87,93 ----
  {
  	struct sock *sk = (struct sock*)data;
  	int why = sk->timeout;
+ 	void tcp_preclose(struct sock *sk);
  
  	/* 
  	 * only process if socket is not in use
***************
*** 94,102 ****
  
  	if (sk->users)
  	{
  		sk->timer.expires = jiffies+HZ;
  		add_timer(&sk->timer);
! 		sti();
  		return;
  	}
  
--- 95,111 ----
  
  	if (sk->users)
  	{
+ 		static int flag = 0;
+ 
+ 		if (why == TIME_DONE && flag < 5) {
+ 			printk("TIME_DONE: sk[%u,%u](%p)->users=%d\n",
+ 				htons(sk->dummy_th.source),
+ 				htons(sk->dummy_th.dest), sk, sk->users);
+ 			flag++;
+ 		}
  		sk->timer.expires = jiffies+HZ;
  		add_timer(&sk->timer);
! 		sti(); /* BRYAN: this looks useless */
  		return;
  	}
  
***************
*** 115,120 ****
--- 124,130 ----
  	{
  		case TIME_DONE:
  			/* If the socket hasn't been closed off, re-try a bit later */
+ 			log_sockevent(sk, 10, sk->dead, sk->state);
  			if (!sk->dead) {
  				reset_timer(sk, TIME_DONE, TCP_DONE_TIME);
  				break;
***************
*** 139,144 ****
--- 149,155 ----
  
  		case TIME_CLOSE:
  			/* We've waited long enough, close the socket. */
+ 			tcp_preclose(sk);
  			sk->state = TCP_CLOSE;
  			delete_timer (sk);
  			if (!sk->dead)
*** linux-2.0.28/net/socket.c	Mon Jul 15 01:31:51 1996
--- KERNEL/net/socket.c	Thu Jul 31 12:02:51 1997
***************
*** 169,175 ****
   *	Obtains the first available file descriptor and sets it up for use. 
   */
  
! static int get_fd(struct inode *inode)
  {
  	int fd;
  
--- 169,175 ----
   *	Obtains the first available file descriptor and sets it up for use. 
   */
  
! int get_fd(struct inode *inode)
  {
  	int fd;
  
